<%@ Page Language="C#"
    MasterPageFile="~/Resources/MasterPages/Modal.Master"
    CodeBehind="EditApproval.aspx.cs"
    Inherits="Inedo.BuildMaster.Web.WebApplication.Applications.EditApproval"
    Title="Create/Edit Approval" %>

<asp:Content ID="AdditionalHeadContent" ContentPlaceHolderID="AdditionalHeadContent" runat="server">
    <script type="text/javascript">
        $(function(){
        
            var $nm =$('#<%=txtName.ClientID %>'),
                $dsc = $('#<%=txtDescription.ClientID %>');
                
            $nm.blur(function(){ 
                if (!$dsc.val())
                    $dsc.val('Approved by ' + $nm.val()).focus();
            });
        });
    </script>
</asp:Content>
<asp:Content ID="MainContent" ContentPlaceHolderID="MainContent" runat="server">

<bm:InfoBox runat="server" BoxType="Warning" Visible="false" ID="ctlApprovalExists">
    An approval already exists with these parameters. Your changes have not been saved.
</bm:InfoBox>

<bm:FormFieldGroup runat="server" ID="ApprovalTypeFormFieldGroup" Narrow="true">
    <Description Heading="Approval Type">
        Select whether the approval should be a particular user or a group.
    </Description>
    <FormFields>
        <bm:StandardFormField runat="server" LabelText="Type:" ID="StandardFormField2">
            <FieldContent>
                <asp:DropDownList runat="server" ID="ddlApprovalType" AutoPostBack="true">
                    <asp:ListItem Text="User" Value="U" />
                    <asp:ListItem Text="Group" Value="G" />
                </asp:DropDownList>
                
                <bm:UpgradeOverviewSlim runat="server" ID="ctlLicensing" />
                
                <noscript>
                    &nbsp;&nbsp;
                    <asp:Button runat="server" 
                        ID="btnApprovalType"
                        Text="Select" 
                        CssClass="button" 
                    />
                </noscript>
            </FieldContent>
        </bm:StandardFormField>     
   </FormFields>
</bm:FormFieldGroup>

<bm:FormFieldGroup runat="server" ID="ctlPrincipalNameFieldGroup" Narrow="true">
    <Description Heading="Name"></Description>

    <FormFields>
        <bm:StandardFormField runat="server" LabelText="Name:" ID="ctlNameFormField">
            <FieldContent>
                <bm:DirectoryBrowser runat="server"
                    ID="txtName"
                    AllowMultiple="false"
                    Required="true"
                    MaxLength="255"
                    Width="210" />
            </FieldContent>
        
        </bm:StandardFormField>
        
   </FormFields>

</bm:FormFieldGroup>

<bm:FormFieldGroup runat="server" ID="ctlGroupMembersFieldGroup" Visible="false" Narrow="true">
    <Description Heading="Users in Group">
        The number of group users required for approval. For example, if three members of BusinessAdmins are required for approval, enter 3.
    </Description>
    <FormFields>
        <bm:StandardFormField runat="server" LabelText="Users in Group:">
            <FieldContent>
                <bm:ValidatingTextBox runat="server"
                    ID="txtUsersInGroup"
                    Type="Integer"
                    Text="1"
                    Required="true"
                    Width="50" />
            </FieldContent>
        </bm:StandardFormField>
    </FormFields>
</bm:FormFieldGroup>

<bm:FormFieldGroup runat="server" ID="ApprovalDescriptionFormFieldGroup" EndGroup="true" Narrow="true">
    <Description Heading="Approval Description">
        Examples: Smoke Tested, Approved by Developers, etc
    </Description>
    <FormFields>
        <bm:StandardFormField runat="server" LabelText="Description:" ID="StandardFormField1">
            <FieldContent>
                <bm:ValidatingTextBox runat="server" ID="txtDescription" MaxLength="100" Width="270" />
            </FieldContent>
        
        </bm:StandardFormField>
        
   </FormFields>

</bm:FormFieldGroup>

<bm:FormFieldGroup runat="server" ID="OrApprovalFormFieldGroup" EndGroup="true" Visible="false" Narrow="true">
    <Description Heading="&quot;Or&quot; Approval">
        Check the box to make this principal the first of an "or" group of approvals. This feature is intended for advanced users of BuildMaster.
    </Description>
    <FormFields>
        <bm:StandardFormField runat="server">
            <FieldContent>
                <asp:CheckBox runat="server"
                    ID="chkOrGroup"
                    Text="&quot;Or&quot; approval (advanced)" />
            </FieldContent>
        </bm:StandardFormField>
    </FormFields>
</bm:FormFieldGroup>

<div class="action-button-container">
    <asp:Button runat="server"
        ID="btnSave"
        Text="Save Approval"
        CssClass="button"
        OnClick="btnSave_Click" />
    
    <bm:CloseModalButtonLink ID="CloseModalButtonLink1"  runat="server" />

</div>
    
    

</asp:Content>
