﻿(function ($) {
    if (!$ || !$.ui || !$.ui.dialog) { alert('Error: JQuery.UI.Dialog library not loaded; cannot add inedobm_dirbrowse plugin.'); return false; }
    if (!$.fn.inedojq_frameddialog) { alert('Error: inedojq_frameddialog library not loaded; cannot add inedobm_dirbrowse plugin.'); return false; }

    $.fn.inedobm_dirbrowse = function (dirbrowseHandlerUrl, o) {

        o = $.extend({
            displayMode: 'Users',
            allowMultiple: false
        }, o);

        this.each(function () {

            var $this = $(this);

            $('<input type="button" value="..." />').insertAfter($this).click(function () {

                var displayModeText = (o.displayMode == 'UsersAndGroups' ? 'Users and Groups' : o.displayMode);

                var selectEntries = function() {
                    var values = [];
                    $dirbrowse.find('input:checked').each(function(){ values.push(this.value); });
                    $this.val(values.join('; '));
                    $dirbrowse.dialog('close');
                };

                var findEntries = function (searchText) {
                    $dirbrowse.find('div.inedobm-dirbrowse-contents').html('<div class="wait">Loading...</div>')
                    $.ajax(dirbrowseHandlerUrl, {
                        success: function (data) {
                            $dirbrowse
                                .find('div.inedobm-dirbrowse-contents')
                                .html(data)
                                .find('input[type=checkbox]')
                                .click(function(){
                                        // if multiple checks aren't allowed, uncheck the remaining boxes if this box is being checked
                                        if (!o.allowMultiple && this.checked)
                                        {
                                            $dirbrowse.find('input[type=checkbox]').prop('checked', false);
                                            this.checked = true;
                                        }
                                    });
                        },
                        error: function (data) {
                            alert((data.status == 404) ? 'The DirectoryBrowser was not found (404).' : data.responseText);
                        },
                        type: 'POST',
                        data: {
                            displayMode: o.displayMode,
                            searchText: searchText
                        }
                    });
                };

                var $dirbrowse =
                    $('<div class="inedobm-dirbrowse"></div>')
                        .appendTo('body')
                        .append
                        (
                            $('<div class="inedobm-dirbrowse-form">')
                                .append('<input type="text" style="margin-right:5px" />')
                                .append
                                (
                                    $('<input type="button" class="buttonMinor" value="Find" />')
                                    .click(function () { findEntries($(this).parent().find('input[type=text]').val()); })
                                )
                        )
                        .append('<div class="inedobm-dirbrowse-contents"></div>')
                        .append
                        ( 
                                $('<div class="inedobm-dirbrowse-buttons" />')
                                .append(
                                    $('<input type="button" value="OK" class="button" />')
                                    .click(function () { selectEntries(); }))
                                .append(
                                    $('<input type="button" value="Cancel" class="buttonMinor" />')
                                    .click(function () { $dirbrowse.dialog('close'); }))
                        )
                        .dialog({
                            modal: true, 
                            title: 'Find ' + displayModeText,
                            height: Math.max(Math.min($(window).height(), 380), 200),
                            width: Math.max(Math.min($(window).width(), 540), 200)
                            })
                        .bind('dialogresize',function(){
                            $(this).find('.inedobm-dirbrowse-contents').height(
                                $(this).height() - (
                                    $(this).find('inedobm-dirbrowse-buttons').height()
                                    + 75
                                ));
                            })
                        .trigger('dialogresize')
                        ;

            });//click
        });//each
        return this;
    };
})(jQuery);
