﻿// inedobm_filetree (based on "jQuery File Tree Plugin" v1.01
(function ($) {
    $.fn.inedobm_filetree = function (o) {

        // Defaults
        o = $.extend({
            loadMessage: 'Loading...',
            multiFolder: true,
            fileTreeHandler: '/_h/file-tree',
            fileSelected: function () { },
            fileDoubleClicked: function () { },
            displayMode: 'FoldersAndFiles',
            serverControlId: null
        }, o);

        $(this).each(function () {

            var $this = $(this);

            function showTree($to, ajaxData) {
                var overriddenServerId = null;
                if (o.serverControlId) {
                    $ctlServer = $('#' + o.serverControlId);
                    overriddenServerId = parseInt($ctlServer.val(), 10);
                    // server name: $ctlServer.children('option:selected').text()
                }
                ajaxData = $.extend({
                    displayMode: o.displayMode,
                    overriddenServerId: overriddenServerId
                }, ajaxData);
                $to.addClass('wait');
                $(".jqueryFileTree.start").remove();
                $.ajax({
                    type: 'POST',
                    url: o.fileTreeHandler,
                    data: ajaxData,
                    success: function (data) {
                        $to.find('.start').html('');
                        $to.removeClass('wait').append(data);
                        $to.children('UL:hidden').show();
                        bindTree($to);
                        if (ajaxData.selectPath) {
                            $this.find('UL:has(A.selected)').show();
                        }
                    },
                    error: function (data) {
                        alert((data.status == 404) ? 'The fileTreeHandler was not found (404).' : data.responseText);
                    }
                });
            }

            function bindTree($to) {
                $to.find('LI A')
                    .click(function () {

                        if ($(this).parent().hasClass('directory')) {

                            if (!$(this).parent().hasClass('directoryLoaded')) {
                                $(this).parent().find('UL').remove(); // cleanup
                                showTree($(this).parent(), { path: $(this).attr('rel') });
                                $(this).parent().addClass('directoryLoaded')
                            }

                            if ($(this).parent().hasClass('collapsed')) {
                                // Expand
                                if (!o.multiFolder) {
                                    $(this).parent().parent().find('UL').hide();
                                    $(this).parent().parent().find('LI.directory').removeClass('expanded').addClass('collapsed');
                                }
                                $(this).parent().children('UL').show();
                                $(this).parent().removeClass('collapsed').addClass('expanded');
                            } else {
                                // Collapse
                                $(this).parent().children('UL').hide();
                                $(this).parent().removeClass('expanded').addClass('collapsed');
                            }
                        } else {
                            o.fileSelected($(this).attr('rel'));
                        }

                        if (!$(this).hasClass('selected')) {
                            $this.find('LI A.selected').removeClass('selected');
                            $(this).addClass('selected');
                        }

                        return false;
                    })
                    .dblclick(function () { o.fileDoubleClicked($(this).attr('rel')) })
                ;
            }

            // Get the initial file list
            showTree($(this), { selectPath: o.selectPath });

            // Loading message
            $(this).html('<ul class="jqueryFileTree start"><li class="wait">' + o.loadMessage + '<li></ul>');
        });
    };

})(jQuery);

(function ($) {
    if (!$) { alert('Error: JQuery library not loaded; cannot add inedobm_filetreebrowser plugin.'); return false; }
    if (!$ || !$.ui || !$.ui.dialog) { alert('Error: JQuery.UI.Dialog library not loaded; cannot add inedobm_filetreebrowser plugin.'); return false; }
    if (!$.fn.inedobm_filetree) { alert('Error: inedobm_filetree not loaded; cannot add inedobm_filetreebrowser plugin.'); return false; }

    $.fn.inedobm_filetreebrowser = function (fileTreeHandler, o) {

        o = $.extend({
            browserTitle: 'Browse Files',
            displayMode: 'FoldersAndFiles',
            serverControlId: null
        }, o);

        $(this).filter('input[type=text]').each(function () {
            var $input = $(this);
            $input.after('&nbsp;').after(
                $('<input type="button" value="..." />').click(function () {
                    var $container = $('<div style="padding-bottom:40px;" />');
                    var $filetree = $('<div style="overflow:auto;height:100%;width:100%;overflow-x:hidden;" />');

                    var fileSelected = function (fileName) { $input.focus().val(fileName).blur(); $container.dialog('close'); };

                    var $buttons =
                        $('<div class="action-button-container" style="position: absolute; right: 15px; bottom: 15px;" />')
                        .append(
                            $('<input type="button" value="Select" class="button" />')
                            .click(function () { fileSelected($container.find('LI A.selected').attr('rel')); }))
                        .append(
                            $('<input type="button" value="Cancel" class="buttonMinor" />')
                            .click(function () { $container.dialog('close'); }));

                    $('body').append($container.append($filetree).append($buttons));

                    $filetree.inedobm_filetree({
                        selectPath: $input.val(),
                        fileTreeHandler: fileTreeHandler,
                        fileDoubleClicked: fileSelected,
                        displayMode: o.displayMode,
                        serverControlId: o.serverControlId
                    });
                    $container.dialog({
                        height: Math.max(Math.min($(window).height(), 380), 200),
                        width: Math.max(Math.min($(window).width(), 540), 200),
                        modal: true,
                        title: o.browserTitle
                    })
                    return;
                })
            );
        });
    };

})(jQuery);


(function ($) {
    if (!$) { alert('Error: JQuery library not loaded; cannot add inedobm_filedownloadbrowser plugin.'); return false; }
    if (!$ || !$.ui || !$.ui.dialog) { alert('Error: JQuery.UI.Dialog library not loaded; cannot add inedobm_filedownloadbrowser plugin.'); return false; }
    if (!$.fn.inedobm_filetree) { alert('Error: inedobm_filetree not loaded; cannot add inedobm_filedownloadbrowser plugin.'); return false; }

    $.fn.inedobm_filedownloadbrowser = function (fileTreeHandler, downloadRemoteFileHandler, o) {

        o = $.extend({
            browserTitle: 'Browse Files'
        }, o);

        $(this).filter('a.button').each(function () {
            var $buttonLink = $(this);
            $buttonLink.click(function () {
                var $container = $('<div style="padding-bottom:40px;" />');
                var $filetree = $('<div style="overflow:auto;height:100%;width:100%;overflow-x:hidden;" />');

                var fileSelected = function (fileName) { 
                    window.location = downloadRemoteFileHandler + '&path=' + encodeURIComponent(fileName); 
                    $container.dialog('close'); 
                };

                var $buttons =
                    $('<div class="action-button-container" style="position: absolute; right: 15px; bottom: 15px;" />')
                    .append(
                        $('<input type="button" value="Download" class="button" />')
                        .click(function () { fileSelected($container.find('LI A.selected').attr('rel')); }))
                    .append(
                        $('<input type="button" value="Cancel" class="buttonMinor" />')
                        .click(function () { $container.dialog('close'); }));

                $('body').append($container.append($filetree).append($buttons));

                $filetree.inedobm_filetree({
                    selectPath: $buttonLink.val(),
                    fileTreeHandler: fileTreeHandler,
                    fileDoubleClicked: fileSelected,
                    displayMode: o.displayMode
                });
                $container.dialog({
                    height: Math.max(Math.min($(window).height(), 380), 200),
                    width: Math.max(Math.min($(window).width(), 540), 200),
                    modal: true,
                    title: o.browserTitle
                });
                return;
            });
        });
    };
})(jQuery);